<?php

namespace Drupal\ddna\Plugin\Seed;

use Drupal\ddna\Annotation\Seed;
use Drupal\ddna\SeedPluginBase;

/**
 * Plugin implementation of the seed.
 *
 * @Seed(
 *   id = "block_type_config_extractor",
 *   label = @Translation("Block Type Config Extractor"),
 *   description = @Translation("Block Type Config Extractor.")
 * )
 */
class BlockTypeConfigExtractor extends SeedPluginBase {
  public function getElements() {
    $table_rows = [];
    $table_header = [
      'Block ID',
      'Theme region',
      'Theme',
      'Weight',
    ];
    $ddna_config_matcher = \Drupal::service('ddna_config_matcher');
    $configs = $ddna_config_matcher->matchAllConfigs($this->configuration['params']['regexp']);
    $blocks = \Drupal::entityTypeManager()->getStorage('block')->loadMultiple();
    foreach ($configs as $element) {
      [,, $block_id] = explode('.', $element);
      $table_rows[] = [
        $blocks[$block_id]->getPluginId(),
        $blocks[$block_id]->getRegion(),
        $blocks[$block_id]->getTheme(),
        $blocks[$block_id]->getWeight(),
      ];
    }

    return [$table_header, $table_rows];
  }
}
