<?php

namespace Drupal\ddna\Plugin\Seed;

use Drupal\ddna\Annotation\Seed;
use Drupal\ddna\SeedPluginBase;
use Drupal\system\MenuStorage;

/**
 * Plugin implementation of the seed.
 *
 * @Seed(
 *   id = "menu_type_config_extractor",
 *   label = @Translation("Menu Type Config Extractor"),
 *   description = @Translation("Menu Type Config Extractor.")
 * )
 */
class MenuTypeConfigExtractor extends SeedPluginBase {

  public function getElements() {
    $table_rows = [];
    $table_header = [
      'Title',
      'Machine name',
      'Description',
    ];
    $ddna_config_matcher = \Drupal::service('ddna_config_matcher');
    $configs = $ddna_config_matcher->matchAllConfigs($this->configuration['params']['regexp']);
    $menus = \Drupal::entityTypeManager()->getStorage('menu')->loadMultiple();
    foreach ($configs as $element) {
      [,, $menu_id] = explode('.', $element);
      $table_rows[] = [
        $menus[$menu_id]->label(),
        $menus[$menu_id]->id(),
        $menus[$menu_id]->getDescription(),
      ];
    }
    return [$table_header, $table_rows];
  }

}
